require "loveballs" --haha, love balls >u<
--Game by Connor "Connorses" McHarney / Loneship Games
--Softbody lib by Shorefire/Steven

function love.load()
   --I've found these to be optimal settings
   love.physics.setMeter(16)
   world = love.physics.newWorld(0, 9.81*16, true)
   world:setCallbacks(beginContact, endContact, preSolve, postSolve) --set the functions that are called upon collision
   love.window.setTitle("Stickiness is OP plz nerf")

   iterations = 3

   player = {}
   stickyJoints = {}

   left = false
   right = false

   speed = 300000

   --Lets make a floor object
   fixed = {}
   addFixed(0,590,800,650)
   addFixed(-50,0,10,600)
   addFixed(790,0,850,600)
   addFixed(0,-50,800,10)

   stickyJointsToAdd = {}
   stickyJoints = {}

   --Now lets make some soft body's
   --World, X, Y, Radius, Smoothing, tesselate count
         --(I set soft1's tesselate count to low, and the 'smoothing' to high, giving a cool effect, similar to loco roco)
   player.soft = Softbody:new(world, 400, 300, 60, 4, 8)
   player.soft:setFrequency(1.5)
   player.soft:setDamping(0.5)
   end

function love.update(dt)
   
   if stickyJointsToAdd ~= nil then
      for i, j in pairs(stickyJointsToAdd) do
         addStickyJoint(j)
      end
      stickyJointsToAdd = {}
   end
   if sticky == false then
      for i in pairs(stickyJoints) do
         if stickyJoints[i] ~= nil then stickyJoints[i]:destroy() end
         stickyJoints[i] = nil
      end
      --stickyJoints = {}
   end
   for i = 1, iterations do
      if right then player.soft:roll(dt*speed) end
      if left then player.soft:roll(-dt*speed) end
      world:update(dt)
      player.soft:update()
   end

   print(world:getJointCount())

end


function love.draw()
   love.graphics.setColor(20,160,20)
   player.soft:draw()
   if sticky then love.graphics.setColor(255,255,255) else love.graphics.setColor(10,80,10) end
   player.soft:draw("line")
   love.graphics.setColor(255,255,255)
   love.graphics.setLineWidth(3)
   for i, f in pairs(fixed) do
      love.graphics.polygon("line", f.body:getWorldPoints(f.shape:getPoints()))
   end
end

function love.keypressed(key)

   if key == "s" then player.soft:setFriction(0) end

   if key == " " then player.soft:setFrequency(7.5) end

   if key == "a" then sticky = true end

   if key == "right" then right = true end

   if key == "left" then left = true end
end

function love.keyreleased(key)

   if key == "s" then player.soft:setFriction(30) end

   if key == " " then player.soft:setFrequency(1.3) end

   if key == "a" then
      sticky = false
   end

   if key == "right" then right = false end

   if key == "left" then left = false end


end

function beginContact(a,b,coll)
   if sticky then
      if a:getUserData() == "node" and b:getUserData() ~= "node" then
         setNextStickyJoint(a,b,coll)
      end
      if b:getUserData() == "node" and a:getUserData() ~= "node" then
         setNextStickyJoint(b,a,coll)
      end
   end
end

function setNextStickyJoint(a,b,coll)
   local newid = table.getn(stickyJointsToAdd)+1
   x1,y1 = coll:getPositions()
   stickyJointsToAdd[newid] = {a:getBody(), b:getBody(), a:getBody():getX(), a:getBody():getY(), x1, y1}
end

function addStickyJoint(joint)
   local newid = table.getn(stickyJoints)+1
   stickyJoints[newid] = love.physics.newDistanceJoint(joint[1],joint[2],joint[3],joint[4],joint[5],joint[6], true)
end

function addFixed(x1,y1,x2,y2)
   local x1 = x1
   local y1 = y1
   local x2 = x2
   local y2 = y2
   local x = x2 - ( (x2-x1)/2 )
   local y = y2 - ( (y2-y1)/2 )
   local newid = table.getn(fixed)+1
   fixed[newid] = {}
   fixed[newid].body = love.physics.newBody(world, x, y, "static")
   fixed[newid].shape = love.physics.newRectangleShape(0,0,x2-x1,y2-y1)
   fixed[newid].fixture = love.physics.newFixture(fixed[newid].body, fixed[newid].shape,5)
end